#ifndef __DSC_CONNECT_H
#define __DSC_CONNECT_H 1

typedef unsigned long dword;
typedef unsigned short word;
typedef unsigned char byte;

struct TDeviceInfo
{
    byte VendorId[10];
    byte ProductId[18];
    byte ProductRevisionLevel[6];
};

class TResponce
{
public:
   ~TResponce() { free(); }
   TResponce() { ptr=0; size=0; }

   bool alloc(unsigned sz) { free(); return 0 != (ptr = new char[size=sz]); }
   void free() { delete [] ptr; ptr=0; size=0; }
   bool set(const void* data, unsigned size);
   bool append(const void* data, unsigned size);

   char* ptr;
   int size;

   const char* GetStr() const { return (const char*)ptr; }
   int GetSize() const { return size; }
};

class DSC
{
   void* handle;

public:

   DSC(void* _handle, const char*);
   virtual ~DSC();

   bool Okay() const { return handle != (void*)(-1); }
   void* GetHandle() const { return handle; }

   virtual bool SetReg(int reg, unsigned value)=0;
   virtual bool GetReg(int reg, unsigned& value)=0;

   virtual bool SetVar(int reg, const void* data, unsigned size) =0;
   virtual bool SetStr(int reg, const char*) =0;
   virtual bool GetVar(int reg, TResponce&) =0;

   virtual bool SpecCmd(int reg, unsigned value, unsigned timeout=0) =0;

   virtual bool GetDeviceInfo(TDeviceInfo&) =0;
   virtual bool CloseCamera() =0;

   enum { PACKET_SIZE = 2048 };

   char comment[8];
};

DSC* OpenCOM(char camera_drive = ' ');
DSC* OpenUSB(char camera_drive = ' ');
bool CheckUSB(char, char*, unsigned);
bool CheckCOM(char, char*, unsigned);
#endif//#ifndef __DSC_CONNECT_H

